----------------------------------------------------------------------------------
--  
--        am_det.vhd        AMg(CORDICŐΒlvZ)
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                      138  out of   2448     5%  
-- Number of Slice Flip Flops:             57  out of   4896     1%  
-- Number of 4 input LUTs:                259  out of   4896     5%  
-- Number of IOs:                          51
-- Number of bonded IOBs:                  49  out of     66    74%  
-- Number of GCLKs:                         1  out of     24     4%  
--
--   Minimum period: 8.666ns (Maximum Frequency: 115.398MHz)
--   Minimum input arrival time before clock: 8.385ns
--   Maximum output required time after clock: 4.040ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
--use IEEE.std_logic_signed.all;

------------------------------------------------------------------------------
entity am_det is 
  port (
    CLK     : in  std_logic;                       -- 
    ND      : in  std_logic;                       -- New Data
    I_IN    : in  std_logic_vector( 15 downto 0 ); -- I M
    Q_IN    : in  std_logic_vector( 15 downto 0 ); -- Q M
    SIG_OUT : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    OD      : out std_logic                        -- o̓f[^Cl[u
  );
end am_det;


------------------------------------------------------------------------------
architecture RTL of am_det is
  
  signal SIG_OUT1 : std_logic_vector( 15 downto 0 ); -- 
  signal X : std_logic_vector( 15 downto 0 ); -- 
  signal Y : std_logic_vector( 15 downto 0 ); -- 
  signal N : std_logic_vector(  4 downto 0 ); -- 
  signal XN : std_logic_vector( 15 downto 0 ); -- N bit Vtg
  signal YN : std_logic_vector( 15 downto 0 ); -- N bit Vtg
  
  component shiftra16
  port (
    X   : in  std_logic_vector( 15 downto 0 ); -- 
    Y   : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector( 3 downto 0 )   -- Vtg
  );
  end component;
  
  
begin
  
  u0 : shiftra16
  port map (
    X   => X,             -- 
    Y   => XN,            -- o̓f[^
    N   => N(3 downto 0)  -- Vtg
  );
  
  
  u1 : shiftra16
  port map (
    X   => Y,             -- 
    Y   => YN,            -- o̓f[^
    N   => N(3 downto 0)  -- Vtg
  );
  
  
  ------------------------------------------------------------------
  --    CORDIC ŐΒlvZiΊp͌vZȂj
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( ND='1' ) then
        if( I_IN(15)='1' ) then                 -- 20090803
          X <= ("00"&(not I_IN(14 downto 1))) + 1;
        else
          X <= ("00"&I_IN(14 downto 1));
        end if;
        
        if( Q_IN(15)='1' ) then
          Y <= ("00"&(not Q_IN(14 downto 1))) + 1;
        else
          Y <= ("00"&Q_IN(14 downto 1));
        end if;
        
        
        N <= (others =>'0');
        OD <= '0';
      elsif( N(4)='0' ) then
        if( Y(15)='0' ) then    -- Y >= 0
          X <= X + YN;
          Y <= Y - XN;
        else                    -- Y < 0
          X <= X - YN;
          Y <= Y + XN;
        end if;
        N <= N+1;
      elsif( N="10000" ) then
        SIG_OUT <= X;
        OD <= '1';
        N <= N+1;
      else
        OD <= '0';
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

