----------------------------------------------------------------------------------
--  
--        dds.vhd        
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                      679  out of   2448    27%  
-- Number of Slice Flip Flops:            665  out of   4896    13%  
-- Number of 4 input LUTs:               1143  out of   4896    23%  
-- 
--   Minimum period: 10.054ns (Maximum Frequency: 99.466MHz)
--   Minimum input arrival time before clock: 4.942ns
--   Maximum output required time after clock: 7.015ns
--   Maximum combinational path delay: No path found
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;
use IEEE.std_logic_arith.all;

------------------------------------------------------------------------------
entity dds is
  port (
    RESET   : in  std_logic;
    CLK     : in  std_logic;                      -- io bus clock
    MCE     : in  std_logic;                      -- Module Chip Enable
    MWE     : in  std_logic;                      -- Module Write Enable
    MADR    : in  std_logic_vector(15 downto 0 ); -- W[AhX
    MWDATA  : in  std_logic_vector( 7 downto 0 ); -- W[֏ރf[^
    
    COS     : out std_logic_vector(17 downto 0);  -- ccrO@o
    SIN     : out std_logic_vector(17 downto 0)
    
  );
end dds;

------------------------------------------------------------------------------
architecture RTL of dds is
  
  signal COS0  : std_logic_vector (17 downto 0);
  signal SIN0  : std_logic_vector (17 downto 0);
  signal FREQ0 : STD_LOGIC_VECTOR (31 downto 0);
--  signal COS1  : std_logic_vector (17 downto 0);
--  signal SIN1  : std_logic_vector (17 downto 0);
--  signal FREQ1 : STD_LOGIC_VECTOR (31 downto 0);
  
  component dds0
  port (
    DDSCLK  : in  std_logic;
    FREQ    : in  std_logic_vector(31 downto 0);    -- g
    COS     : out std_logic_vector(17 downto 0);    -- RTCo
    SIN     : out std_logic_vector(17 downto 0)     -- TCo
  );
  end component;
  
  
  begin
    
    u0 : dds0
    port map (
      DDSCLK  => CLK,
      FREQ    => FREQ0,       -- g
      COS     => COS0,        -- RTCo
      SIN     => SIN0         -- TCo
    );
    
--    u1 : dds0
--    port map (
--      DDSCLK  => CLK,
--      FREQ    => FREQ1,       -- g
--      COS     => COS1,        -- RTCo
--      SIN     => SIN1         -- TCo
--    );
    
    COS <= COS0;
    SIN <= SIN0;
--    SIN <= COS1;
    
    
    ------------------------------------------------------------------
    --    eccr̎gݒ
    ------------------------------------------------------------------
    process( RESET, CLK ) begin
      if ( RESET ='1') then
--        FREQ0 <= (others => '0');
--        FREQ0 <= X"0000A7C5";           -- 1kHz
--        FREQ0 <= X"00014F8B";           --2kHz
--        FREQ0 <= X"027125DD";           --954.125kHz
        FREQ0 <= X"02E84D3D";           --954kHz @CLK=84MHz
--        FREQ1 <= X"0000DA1A";           -- 1.3kHz
--        FREQ1 <= X"00000863";           -- 50Hz
      elsif( rising_edge(CLK) ) then
        if( MWE='1' and MCE='1' ) then
          case MADR( 2 downto 0 ) is
            when( "000" ) => FREQ0( 7 downto  0) <= MWDATA;    -- gݒ ccrO
            when( "001" ) => FREQ0(15 downto  8) <= MWDATA;    -- gݒ ccrO
            when( "010" ) => FREQ0(23 downto 16) <= MWDATA;    -- gݒ ccrO
            when others   => FREQ0(31 downto 24) <= MWDATA;    --
--            when( "100" ) => FREQ1( 7 downto  0) <= MWDATA;    -- gݒ ccrO
--            when( "101" ) => FREQ1(15 downto  8) <= MWDATA;    -- gݒ ccrO
--            when( "110" ) => FREQ1(23 downto 16) <= MWDATA;    -- gݒ ccrO
--            when others   => FREQ1(31 downto 24) <= MWDATA;    --
          end case;
        end if;
      end if;
    end process;
    
    
  end RTL;
----------------------------- end of architecture ----------------------------
