----------------------------------------------------------------------------------
--  
--        shiftra16.vhd        ZpEVtg@16rbgf[^
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷ȂǏƓIp͂߂B
--
--
-- Number of Slices:                       32  out of   2448     1%  
-- Number of 4 input LUTs:                 59  out of   4896     1%  
--
--   Minimum period: No path found
--   Minimum input arrival time before clock: No path found
--   Maximum output required time after clock: No path found
--   Maximum combinational path delay: 9.567ns
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity shiftra16 is 
  port (
    X   : in  std_logic_vector( 15 downto 0 ); -- 
    Y   : out std_logic_vector( 15 downto 0 ); -- o̓f[^
    N   : in  std_logic_vector( 3 downto 0 )   -- Vtg
  );
end shiftra16;


------------------------------------------------------------------------------
architecture RTL of shiftra16 is
  
  signal X1 : std_logic_vector( 15 downto 0 ); -- 1 bit Vtg
  signal X2 : std_logic_vector( 15 downto 0 ); -- 2 bit Vtg
  signal X4 : std_logic_vector( 15 downto 0 ); -- 4 bit Vtg
  
  begin
    
    X1 <= X  when( N(0)='0' ) else
          X(15) & X(15 downto 1);
    
    X2 <= X1 when( N(1)='0' ) else
          X1(15) & X1(15) & X1(15 downto 2);
    
    X4 <= X2 when( N(2)='0' ) else
          X2(15) & X2(15) & X2(15) & X2(15) & X2(15 downto 4);
    
    Y  <= X4 when( N(3)='0' ) else
          X4(15) & X4(15) & X4(15) & X4(15) & X4(15) & X4(15) & X4(15) & X4(15) & X4(15 downto 8);
    
    
  end RTL;
----------------------------- end of architecture ----------------------------

