----------------------------------------------------------------------------------
--  
--        signature.vhd        fUCAo[WԂ
--  
--        (c)2009/07/26  by OjisanKoubou
--  
----------------------------------------------------------------------------------
--  
--  ̃vO Ojisankoubou( OGAWA Ichiro ) 쌠Ă܂B
--  ľړIɂ́ACAȂǎRɎgpł܂B
--  \ۂ͒쌠\Ȃ悤ɂĂB
--  ̃\tgEFȂS͈ꕔ𐻕iɑgݍ񂾂̔肷Ȃǂ
--  ƓIp͂߂B
--


library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_unsigned.all;

------------------------------------------------------------------------------
entity signature is 
  port (
    CLK       : in  std_logic;                      -- I/O clock
    
    MCE       : in  std_logic;                      -- module select
    MWE       : in  std_logic;                      -- Module Write Enable
    MADR      : in  std_logic_vector(15 downto 0);  -- address bus
    MWDATA    : in  std_logic_vector(7 downto 0 );  -- W[݃f[^
    MRDATA    : out std_logic_vector( 7 downto 0)   -- data bus output
  );
end signature;


------------------------------------------------------------------------------
architecture RTL of signature is
  
  subtype B8 is STD_LOGIC_VECTOR (7 downto 0);
  type SIGTABLE is array (0 to 15) of B8;
  signal SIGNATURE :SIGTABLE := (
       X"41", X"50", X"42", X"32", X"5F", X"52", X"41", X"44",   -- fUC  APB2_RAD  
       X"32", X"30", X"31", X"31", X"30", X"39", X"32", X"32"    -- o[W  20110922
       );
  
begin
  
  ------------------------------------------------------------------
  --    ǂݏo
  ------------------------------------------------------------------
  MRDATA   <= (others =>'0') when(MCE='0') else
              SIGNATURE(CONV_INTEGER(MADR(3 downto 0)));
  
  
  ------------------------------------------------------------------
  --    
  ------------------------------------------------------------------
  process( CLK ) begin
    if( rising_edge(CLK) ) then
      if( MWE='1' and MCE ='1' ) then
        SIGNATURE(CONV_INTEGER(MADR(3 downto 0))) <= MWDATA;
      end if;
    end if;
  end process;
  
  
end RTL;
----------------------------- end of architecture ----------------------------

